# -*- coding: utf-8 -*-

#1a) Si scriva la funzione indexall(s, sub, overlap=True) che, data una stringa 
# s e una potenziale sua sottostringa sub, restituisca una lista (ordinata) 
# con gli indici di tutte le occorrenze di sub in s. Se il parametro overlap è 
# posto a True, occorre considerare tutte le occorrenze, indipendentemente dal 
# fatto che possano sovrapporsi tra loro; altrimenti, la funzione dovrà scartare 
# le occorrenze che iniziano prima della fine dell'occorrenza precedentemente 
# rilevata, partendo dall'inizio di s.
# ATTENZIONE: l'implementazione sviluppata NON deve far uso delle funzioni 
# standard "find", "index", "in", ecc. che operano su stringhe.
#
# Es. 
# x="ababaxababaaba"
# indexall(s,"aba")          # -> [0, 2, 6, 8, 11]
# indexall(s,"aba", False)   # -> [0, 6, 11]


def indexall(s, sub, overlap=True):
    """
    Returns a list with the indices of the occurrences in s of the substring s.
    If overlap is True, all occurrences are considered, regardless of their 
    overlapping; othervise, an occurrence is not considered if it begins before
    the end of the previous occurrence.
    """ 
    res=[]
    ls=len(s)
    lsub=len(sub)
    top=ls-lsub
    i=0
    while i <= top:
        if s[i:i+lsub]==sub:
            res.append(i)
            if not overlap:
                i+=lsub
        i+=1
    return res
    