# -*- coding: utf-8 -*-

#2a) Si generalizzi la funzione definita al punto 1a) considerando non solo le 
# porzioni di s che siano uguali a sub, ma tutte quelle la cui distanza di 
# Hamming da sub sia <= a un valore maxdist fornito in ingresso.
# Per tale funzione si usi la signature:
# indexallhamming(s, sub, maxdist=0, overlap=True) dove il parametro overlap ha
# lo stesso significato descritto precedentemente.
#
# Es. 
# x="ababaxababaaba"
# indexallhamming(s,"aba", 1)        # -> [0, 2, 4, 6, 8, 11]
# indexallhamming(s,"aba", 2)        # -> [0, 2, 4, 6, 8, 9, 10, 11]
# indexallhamming(s,"aba", 1, False) # -> [0, 4, 8]


def indexallhamming(s, sub, maxdist=0, overlap=True):
    """
    Returns a list with the indices of the substrings in s whose Hamming 
    distance from sub is <= maxdist.
    If overlap is True, all substrings are considered, regardless of their 
    overlapping; othervise, a substring is not considered if it begins before
    the end of the previous matching substring.
    """ 
    ls   = len(s)
    lsub = len(sub)
    top  = ls-lsub
    res = []
    i = 0
    while i <= top:
        d = 0
        for j in xrange(lsub):
            if s[i+j] != sub[j]:
                d+=1
            if d > maxdist:
                break
        if d <= maxdist:
            res.append(i)
            if not overlap:
                i+=lsub
        i+=1
    return res
