# -*- coding: utf-8 -*-

#3b) I file ATP8_variant1.fasta e ATP8_variant1.fasta contengono ciascuno la 
# sequenza mutata in una sola porzione del dna mitocondriale che codifica la 
# proteina "ATP syntase 8". Utilizzando le funzionalità sviluppate ai punti 
# precedenti, determinare quale delle due contiene una mutazione SINONIMA e 
# fornire in output sul file uso3.txt (su righe separate):
# 1) il nome del file che contiene la variante con mutazione sinonima;
# 2) il numero del relativo codone interessato;
# 3) la coordinata della mutazione all'interno del dna mitocondriale. 
# Riguardo ai punti 2) e 3), si adotti la convenzione che il primo elemento 
# abbia indice 1.


from soluzione2 import indexallhamming
from soluzione3 import check_same_prot
import Bio.SeqIO as SeqIO

filemito = "mitochondrion.fasta"
filevar = ["ATP8_variant1.fasta","ATP8_variant2.fasta"]
outfile = "uso3.txt"

mito = str(SeqIO.read(filemito, format="fasta").seq)
var  = [str(SeqIO.read(f, format="fasta").seq) for f in filevar]

#next: positions of the "wild-type" counterparts in the genome 
t = [indexallhamming(mito, v, 1) for v in var] 

# just to check it, we proceed only in case both variants refer to the same 
# genome portion ("target" hereafter)
if t[0][0]==t[1][0]:   
    target = mito[t[0][0]:t[0][0]+len(var[0])]
    rna_target = target.replace("T","U")   
    rna_var = [v.replace("T","U") for v in var]
    
    correct_i=-1
    for i in xrange(len(var)):
        if check_same_prot(rna_target, rna_var[i]):
            correct_i=i
            break
    if correct_i>0:
        #calculate mutation position
        for pos, pair in enumerate(zip(rna_target, rna_var[correct_i])):
            if pair[0]!=pair[1]:
                break
        
        with open(outfile, "w") as f:
            f.write(filevar[correct_i]+"\n")
            f.write(str(pos/3+1)+"\n")
            f.write(str(t[0][0]+pos+1)+"\n")
    